proc Cmas2d::WriteCalculationFile { filename } {

customlib::InitWriteFile $filename

set xp1 {container[@n="Properties"]/condition[@n="Shells"]/group}
set xp2 ".//value\[@n='material']"

# We will save a TCL dictionary with the information requested (materials & beam information)
set mat_dict ""
set material_number 0
set formats ""

set root [$::gid_groups_conds::doc documentElement]
foreach gNode [$root selectNodes $xp1] {
set valueNode [$gNode selectNodes $xp2]
set material_name [get_domnode_attribute $valueNode v]
if { ![dict exists $mat_dict $material_name] } {
incr material_number
set mid $material_number

#We also save the density of the material by checking the material database
set xp3 {/*/container[@n="Properties"]/container[@n="materials"]//}
append xp3 [format_xpath {blockdata[@n="material" and @name=%s]/value[@n="Density"]} $material_name]
set valueNode [$root selectNodes $xp3]
# All the introduced values are translated to 'm' and 'kg' with the help of this function
set density [gid_groups_conds::convert_value_to_default $valueNode]

dict set mat_dict $material_name MID $material_number
dict set mat_dict $material_name DENSITY [format "%13.5E" $density]
} else {
set mid [dict get $mat_dict $material_name MID]
}
set f {\n%10d %10d %10d %10d [format "%10d" $mid]}
set f [subst $f]
dict set formats [$gNode @n] $f
}

if {$material_number=="0"} {
error [= "Remember to define your surface/s as shell/s"]
}

# Beams applied on lines
set xp3 {condition[@n="beam"]/group}
foreach gNode [$root selectNodes $xp3] {
set valueNode [$gNode selectNodes {value[@n="Weight"]}]
set weight [gid_groups_conds::convert_value_to_default $valueNode]
set f {\n%10d %10d %10d $weight}
set f [subst $f]
dict set formats [$gNode @n] $f
}
if {[GiD_WriteCalculationFile has_elements -elemtype {"Triangle" "Linear"} $formats]} {
GiD_WriteCalculationFile connectivities -do_subst -elemtype {"Triangle" "Linear"} $formats
} else {
error [= "Only Triangle and Linear elements are allowed in this version of the problemtype"]
}
customlib::EndWriteFile ;#finish writting
}